﻿package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.ColorTransform;
	import flash.geom.Point;
	
    import flash.media.Microphone;
    import flash.system.Security;
    import flash.system.SecurityPanel;
	
	
	public class Coliner extends Sprite
	{
		private var angle:Number = 0;
		private var path:Array;
		private var pathHeight:Number;
		private var image:BitmapData;
		private var c_trs:ColorTransform = new ColorTransform (1, 1, 1, 0.9); //echo : 0.999
		private var support:Sprite = new Sprite();
		
		var myMic:Microphone = Microphone.getMicrophone();
		Security.showSettings(SecurityPanel.MICROPHONE);
		
		public function Coliner()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		private function addedHandler(e:Event):void{
			addChild (new Bitmap (image = new BitmapData(stage.stageWidth, stage.stageHeight,false,0x000000)));
			this.addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		private function enterHandler(e:Event):void
		{
			myMic.setLoopBack(true);
			myMic.setUseEchoSuppression(true);
			
			support.graphics.clear();
			support.graphics.moveTo(0,stage.stageHeight-300);
			var mX:Number = myMic.activityLevel*6;
			var color:Number = Math.random()*0xff0000;
			for(var i:Number=0;i<stage.stageWidth;i++){
				var posy:Number = Math.sin((i+angle/10)*Math.PI/180)*Math.cos(i*Math.PI/180)*(stage.stageWidth/2-i)*(mX/15);
				support.graphics.lineStyle(mX/25,color);
				support.graphics.lineTo(i*1,stage.stageHeight-300+posy);
			}
			angle+=1*(mX/10);
			image.colorTransform (image.rect, c_trs);
			image.scroll (-0.8, -1);
			image.draw(support);
		}
	}
}